#include <windows.h>
#include <string>
#include <stdio.h>

using namespace std;

LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam,
                                     LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPreInst,
                       LPSTR lpszCmdLine, int nCmdShow)
{
     HWND          hWnd;
     MSG               msg;
     WNDCLASSEX     wc;

     //fill the WNDCLASSEX structure with the appropriate values
     wc.cbSize = sizeof(WNDCLASSEX);
     wc.style = CS_HREDRAW | CS_VREDRAW;
     wc.lpfnWndProc = WndProc;
     wc.cbClsExtra = 0;
     wc.cbWndExtra = 0;
     wc.hInstance = hInst;
     wc.hIcon = LoadIcon(NULL, IDI_EXCLAMATION);
     wc.hCursor = LoadCursor(NULL, IDC_ARROW);
     wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
     wc.lpszMenuName = NULL;
     wc.lpszClassName = "Hallo World";
     wc.hIconSm = LoadIcon(NULL, IDI_EXCLAMATION);

     //register the new class
     RegisterClassEx(&wc);

     //create a window
     hWnd = CreateWindowEx(
          WS_EX_APPWINDOW,
          "Hallo World",
          "The Hallo World Program",
          WS_OVERLAPPEDWINDOW | WS_VISIBLE,
          CW_USEDEFAULT,
          CW_USEDEFAULT,
          CW_USEDEFAULT,
          CW_USEDEFAULT,
          NULL,
          NULL,
          hInst,
          NULL
     );

     //event loop - handle all messages
     while(GetMessage(&msg, NULL, 0, 0))
     {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
     }

     //standard return value
     return (msg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam,
                                     LPARAM lParam)
{
     static int Ticks = 0;
     //device context used for drawing
     HDC hDC;
     
     //find out which message is being sent
     switch(nMsg)
     {
          case WM_CREATE:
               //create the timer (0.1 seconds)
               SetTimer(hWnd, 1, 100, NULL);
               break;
     
          case WM_PAINT:
               PAINTSTRUCT ps;
               hDC = BeginPaint (hWnd, &ps);
               TextOut (hDC, 0, 0, "Hallo, world!", 13);
               EndPaint (hWnd, &ps);    
               break;

          case WM_TIMER: //when the timer goes off (only one)
               //get the dc for drawing
               hDC = GetDC(hWnd);
               if (Ticks % 10 == 0)
               {
                   char text[20];
                   sprintf (text, "%i", Ticks/10);
                   TextOut (hDC, 0, 20, text, strlen(text));
               };
               Ticks = (Ticks+1) % 1000000;
               ReleaseDC(hWnd, hDC);
               break;

          case WM_DESTROY:
               //destroy the timer
               KillTimer(hWnd, 1);
               //end the program
               PostQuitMessage(0);
               break;

          case WM_KEYDOWN:
               if (wParam == VK_ESCAPE)
               {
                   SendMessage(hWnd, WM_DESTROY, 0, 0);
               }
               else
               {
                   char text[20];
                   sprintf (text, "%i", wParam);
                   hDC = GetDC(hWnd);
                   TextOut (hDC, 0, 40, "       ", 7);
                   TextOut (hDC, 0, 40, text, strlen(text));
                   ReleaseDC(hWnd, hDC);
               };
               break;
     
          default:
               //let Windows handle every other message
               return(DefWindowProc(hWnd, nMsg, wParam, lParam));
     }

     return 0;
}
